"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs2/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = wrapConversationMercury;

var _assign = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/assign"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _reactTransformHmr3 = _interopRequireDefault(require("react-transform-hmr"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _reactComponentUtils = require("@ciscospark/react-component-utils");

var _reduxModuleConversation = require("@ciscospark/redux-module-conversation");

var _components = {
  ConversationMercuryComponent: {
    displayName: "ConversationMercuryComponent",
    isInFunction: true
  }
};

var _reactTransformHmr2 = (0, _reactTransformHmr3.default)({
  filename: "packages/node_modules/@ciscospark/react-hoc-conversation-mercury/src/index.js",
  components: _components,
  locals: [module],
  imports: [_react.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformHmr2(Component, id);
  };
}

var IS_LISTENING = 'isListeningToMercury';

function wrapConversationMercury(WrappedComponent) {
  var injectedPropTypes = {
    addParticipant: _propTypes.default.func.isRequired,
    conversation: _propTypes.default.object.isRequired,
    mercury: _propTypes.default.object.isRequired,
    receiveMercuryActivity: _propTypes.default.func.isRequired,
    receiveMercuryComment: _propTypes.default.func.isRequired,
    removeParticipant: _propTypes.default.func.isRequired,
    spark: _propTypes.default.object.isRequired,
    updateConversationState: _propTypes.default.func.isRequired
  };

  var ConversationMercuryComponent =
  /*#__PURE__*/
  function (_Component) {
    (0, _inherits2.default)(ConversationMercuryComponent, _Component);

    function ConversationMercuryComponent() {
      (0, _classCallCheck2.default)(this, ConversationMercuryComponent);
      return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ConversationMercuryComponent).apply(this, arguments));
    }

    (0, _createClass2.default)(ConversationMercuryComponent, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.listenToMercury(this.props);
      }
    }, {
      key: "componentWillReceiveProps",
      value: function componentWillReceiveProps(nextProps) {
        this.listenToMercury(nextProps);
      }
    }, {
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate(nextProps) {
        return nextProps !== this.props;
      }
    }, {
      key: "listenToMercury",
      value: function listenToMercury(props) {
        var mercury = props.mercury,
            conversation = props.conversation,
            spark = props.spark;
        var mecuryConnected = mercury.getIn(['status', 'connected']);
        var conversationId = conversation.get('id');
        var isListening = conversation.getIn(['status', IS_LISTENING]);

        if (mecuryConnected && conversationId && !isListening) {
          this.listenToNewActivity(conversationId, spark);
          var conversationState = {};
          conversationState[IS_LISTENING] = true;
          this.props.updateConversationState(conversationState);
        }
      }
      /**
       * Setup listeners for new activities
       *
       * @param {String} conversationId
       * @param {Object} sparkInstance
       * @returns {undefined}
       */

    }, {
      key: "listenToNewActivity",
      value: function listenToNewActivity(conversationId, sparkInstance) {
        var _this = this;

        sparkInstance.internal.mercury.on('event:conversation.activity', function (event) {
          var activity = (0, _assign.default)({
            alertType: event.alertType
          }, event.data.activity); // Reply activities are not currently supported

          if (activity.type === _reactComponentUtils.API_ACTIVITY_TYPE.REPLY) {
            return;
          } // Ignore activity from other conversations


          if (activity.target && activity.target.id === conversationId) {
            if (activity.object.objectType === 'activity') {
              _this.props.receiveMercuryActivity(activity);
            } else if (activity.object.objectType === 'person') {
              if (activity.verb === _reactComponentUtils.API_ACTIVITY_VERB.ADD) {
                _this.props.addParticipant(activity.object);
              } else if (activity.verb === _reactComponentUtils.API_ACTIVITY_VERB.LEAVE) {
                _this.props.removeParticipant(activity.object);
              }

              _this.props.receiveMercuryComment(activity);
            } else {
              _this.props.receiveMercuryComment(activity);
            }
          }
        });
      }
    }, {
      key: "render",
      value: function render() {
        return _react.default.createElement(WrappedComponent, this.props);
      }
    }]);
    return ConversationMercuryComponent;
  }(_react.Component);

  ConversationMercuryComponent = _wrapComponent("ConversationMercuryComponent")(ConversationMercuryComponent);
  ConversationMercuryComponent.displayName = "ConversationMercuryComponent(".concat((0, _reactComponentUtils.getDisplayName)(WrappedComponent), ")");
  ConversationMercuryComponent.WrappedComponent = WrappedComponent;
  ConversationMercuryComponent.propTypes = injectedPropTypes;
  return (0, _reactRedux.connect)(function (state) {
    return {
      conversation: state.conversation,
      mercury: state.mercury,
      spark: state.spark.get('spark')
    };
  }, function (dispatch) {
    return (0, _redux.bindActionCreators)({
      addParticipant: _reduxModuleConversation.addParticipant,
      receiveMercuryActivity: _reduxModuleConversation.receiveMercuryActivity,
      receiveMercuryComment: _reduxModuleConversation.receiveMercuryComment,
      removeParticipant: _reduxModuleConversation.removeParticipant,
      updateConversationState: _reduxModuleConversation.updateConversationState
    }, dispatch);
  })(ConversationMercuryComponent);
}